Index: /trunk/configure.ac
===================================================================
--- /trunk/configure.ac	(revision 5749)
+++ /trunk/configure.ac	(revision 5750)
@@ -25,5 +25,5 @@
 #########################
 AC_PREREQ(2.59)
-AC_INIT([orxonox],[0.3.2_alpha],[orxonox-dev at mail.datacore.ch])
+AC_INIT([orxonox], [0.3.2_alpha], [orxonox-dev at mail.datacore.ch])
 
 ## Detect the canonical host and target build environment.
@@ -34,5 +34,5 @@
 AM_INIT_AUTOMAKE
 
-AC_CONFIG_SRCDIR([.])
+AC_CONFIG_SRCDIR([src])
 AC_CONFIG_HEADER([config.h])
 
Index: /trunk/depcomp
===================================================================
--- /trunk/depcomp	(revision 5749)
+++ /trunk/depcomp	(revision 5750)
@@ -2,5 +2,5 @@
 # depcomp - compile a program generating dependencies as side-effects
 
-scriptversion=2005-07-09.11
+scriptversion=2005-02-09.22
 
 # Copyright (C) 1999, 2000, 2003, 2004, 2005 Free Software Foundation, Inc.
@@ -18,6 +18,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
-# 02110-1301, USA.
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+# 02111-1307, USA.
 
 # As a special exception to the GNU General Public License, if you
@@ -468,6 +468,5 @@
 
   "$@" -E |
-    sed -n -e '/^# [0-9][0-9]* "\([^"]*\)".*/ s:: \1 \\:p' \
-       -e '/^#line [0-9][0-9]* "\([^"]*\)".*/ s:: \1 \\:p' |
+    sed -n '/^# [0-9][0-9]* "\([^"]*\)".*/ s:: \1 \\:p' |
     sed '$ s: \\$::' > "$tmpdepfile"
   rm -f "$depfile"
Index: /trunk/install-sh
===================================================================
--- /trunk/install-sh	(revision 5749)
+++ /trunk/install-sh	(revision 5750)
@@ -2,5 +2,5 @@
 # install - install a program, script, or datafile
 
-scriptversion=2005-05-14.22
+scriptversion=2005-02-02.21
 
 # This originates from X11R5 (mit/util/scripts/install.sh), which was
Index: /trunk/missing
===================================================================
--- /trunk/missing	(revision 5749)
+++ /trunk/missing	(revision 5750)
@@ -2,5 +2,5 @@
 # Common stub for a few missing GNU programs while installing.
 
-scriptversion=2005-06-08.21
+scriptversion=2005-02-08.22
 
 # Copyright (C) 1996, 1997, 1999, 2000, 2002, 2003, 2004, 2005
@@ -20,6 +20,6 @@
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
-# 02110-1301, USA.
+# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
+# 02111-1307, USA.
 
 # As a special exception to the GNU General Public License, if you
@@ -298,7 +298,4 @@
       test -z "$file" && file=`echo "$infile" | sed 's,.*/,,;s,.[^.]*$,,'`.info
     fi
-    # If the file does not exist, the user really needs makeinfo;
-    # let's fail without touching anything.
-    test -f $file || exit 1
     touch $file
     ;;
Index: /trunk/mkinstalldirs
===================================================================
--- /trunk/mkinstalldirs	(revision 5749)
+++ /trunk/mkinstalldirs	(revision 5750)
@@ -2,5 +2,5 @@
 # mkinstalldirs --- make directory hierarchy
 
-scriptversion=2005-06-29.22
+scriptversion=2005-02-02.21
 
 # Original author: Noah Friedman <friedman@prep.ai.mit.edu>
@@ -13,5 +13,5 @@
 
 errstatus=0
-dirmode=
+dirmode=""
 
 usage="\
@@ -104,19 +104,11 @@
 for file
 do
-  case $file in
-    /*) pathcomp=/ ;;
-    *)  pathcomp= ;;
-  esac
-  oIFS=$IFS
-  IFS=/
-  set fnord $file
+  set fnord `echo ":$file" | sed -ne 's/^:\//#/;s/^://;s/\// /g;s/^#/\//;p'`
   shift
-  IFS=$oIFS
 
+  pathcomp=
   for d
   do
-    test "x$d" = x && continue
-
-    pathcomp=$pathcomp$d
+    pathcomp="$pathcomp$d"
     case $pathcomp in
       -*) pathcomp=./$pathcomp ;;
@@ -133,5 +125,5 @@
 	if test ! -z "$dirmode"; then
 	  echo "chmod $dirmode $pathcomp"
-	  lasterr=
+	  lasterr=""
 	  chmod "$dirmode" "$pathcomp" || lasterr=$?
 
@@ -143,5 +135,5 @@
     fi
 
-    pathcomp=$pathcomp/
+    pathcomp="$pathcomp/"
   done
 done
Index: /trunk/src/Makefile.am
===================================================================
--- /trunk/src/Makefile.am	(revision 5749)
+++ /trunk/src/Makefile.am	(revision 5750)
@@ -48,6 +48,7 @@
                   world_entities/camera.cc \
                   world_entities/player.cc \
-                  world_entities/npc.cc \
-                  world_entities/npc2.cc \
+                  world_entities/npcs/npc.cc \
+                  world_entities/npcs/npc_test1.cc \
+                  world_entities/npcs/npc_test.cc \
                   world_entities/environment.cc \
                   world_entities/skysphere.cc \
@@ -62,8 +63,12 @@
                   world_entities/weapons/test_gun.cc \
                   world_entities/weapons/turret.cc \
+                  world_entities/weapons/ground_turret.cc \
+                  world_entities/weapons/aiming_turret.cc \
+                  world_entities/weapons/cannon.cc \
                   world_entities/weapons/test_bullet.cc \
                   world_entities/weapons/rocket.cc \
                   world_entities/weapons/laser.cc \
                   world_entities/weapons/aim.cc \
+                  world_entities/weapons/bomb.cc \
                   world_entities/weapons/crosshair.cc \
                   world_entities/power_ups/power_up.cc \
@@ -82,6 +87,7 @@
                  world_entities/camera.h \
                  world_entities/player.h \
-                 world_entities/npc.h \
-                 world_entities/npc2.h \
+                 world_entities/npcs/npc.h \
+                 world_entities/npcs/npc_test.h \
+                 world_entities/npcs/npc_test1.h \
                  world_entities/environment.h \
                  world_entities/skysphere.h \
@@ -95,9 +101,12 @@
                  world_entities/weapons/projectile.h \
                  world_entities/weapons/test_gun.h \
+                 world_entities/weapons/cannon.h \
                  world_entities/weapons/turret.h \
+                 world_entities/weapons/aiming_turret.h \
                  world_entities/weapons/test_bullet.h \
                  world_entities/weapons/rocket.h \
                  world_entities/weapons/laser.h \
                  world_entities/weapons/aim.h \
+                 world_entities/weapons/bomb.h \
                  world_entities/weapons/crosshair.h \
                  world_entities/power_ups/power_up.h \
Index: /trunk/src/defs/class_id.h
===================================================================
--- /trunk/src/defs/class_id.h	(revision 5749)
+++ /trunk/src/defs/class_id.h	(revision 5750)
@@ -135,10 +135,12 @@
   CL_TEST_GUN                   =    0x00000230,
   CL_TURRET                     =    0x00000231,
-
+  CL_AIMING_TURRET              =    0x00000232,
+  CL_CANNON                     =    0x00000233,
 
   CL_TEST_BULLET                =    0x00000240,
   CL_ROCKET                     =    0x00000241,
   CL_LASER                      =    0x00000242,
-
+  CL_BOMB                       =    0x00000243,
+  CL_GROUND_TURRET		=    0x00000244,
 
   // gamePlay (range from 0x00000500 0x000005ff)
Index: /trunk/src/lib/coord/p_node.h
===================================================================
--- /trunk/src/lib/coord/p_node.h	(revision 5749)
+++ /trunk/src/lib/coord/p_node.h	(revision 5750)
@@ -70,4 +70,5 @@
   inline const Vector& getAbsCoor () const { return this->absCoordinate; };
   void shiftCoor (const Vector& shift);
+  void shiftCoor (float x, float y, float z) { this->shiftCoor(Vector(x, y, z)); };
 
   void setRelDir (const Quaternion& relDir);
@@ -127,4 +128,6 @@
   static const char* parentingModeToChar(int parentingMode);
   static PARENT_MODE charToParentingMode(const char* parentingMode);
+
+
  private:
   void init(PNode* parent);
Index: /trunk/src/lib/graphics/light.cc
===================================================================
--- /trunk/src/lib/graphics/light.cc	(revision 5749)
+++ /trunk/src/lib/graphics/light.cc	(revision 5750)
@@ -29,5 +29,5 @@
 using namespace std;
 
-CREATE_FACTORY(Light);
+CREATE_FACTORY(Light, CL_LIGHT);
 
 //! Definition of the Lights and their Names
Index: /trunk/src/lib/gui/gl_gui/glmenu/glmenu_imagescreen.cc
===================================================================
--- /trunk/src/lib/gui/gl_gui/glmenu/glmenu_imagescreen.cc	(revision 5749)
+++ /trunk/src/lib/gui/gl_gui/glmenu/glmenu_imagescreen.cc	(revision 5750)
@@ -25,5 +25,5 @@
 #include "load_param.h"
 
-CREATE_FACTORY(GLMenuImageScreen);
+CREATE_FACTORY(GLMenuImageScreen, CL_GLMENU_IMAGE_SCREEN);
 
 using namespace std;
Index: /trunk/src/lib/particles/particle_emitter.cc
===================================================================
--- /trunk/src/lib/particles/particle_emitter.cc	(revision 5749)
+++ /trunk/src/lib/particles/particle_emitter.cc	(revision 5750)
@@ -29,5 +29,5 @@
 
 
-CREATE_FACTORY(ParticleEmitter);
+CREATE_FACTORY(ParticleEmitter, CL_PARTICLE_EMITTER);
 
 /**
Index: /trunk/src/lib/particles/particle_system.cc
===================================================================
--- /trunk/src/lib/particles/particle_system.cc	(revision 5749)
+++ /trunk/src/lib/particles/particle_system.cc	(revision 5750)
@@ -32,5 +32,5 @@
 #include "tinyxml.h"
 
-CREATE_FACTORY(ParticleSystem);
+CREATE_FACTORY(ParticleSystem, CL_PARTICLE_SYSTEM);
 SHELL_COMMAND(texture, ParticleSystem, setMaterialTexture)
     ->defaultValues(1, "maps/evil-flower.png");
Index: /trunk/src/lib/physics/fields/gravity.cc
===================================================================
--- /trunk/src/lib/physics/fields/gravity.cc	(revision 5749)
+++ /trunk/src/lib/physics/fields/gravity.cc	(revision 5750)
@@ -23,5 +23,5 @@
 using namespace std;
 
-CREATE_FACTORY(Gravity);
+CREATE_FACTORY(Gravity, CL_FIELD_GRAVITY);
 
 Gravity::Gravity(const TiXmlElement* root)
Index: /trunk/src/lib/physics/physics_connection.cc
===================================================================
--- /trunk/src/lib/physics/physics_connection.cc	(revision 5749)
+++ /trunk/src/lib/physics/physics_connection.cc	(revision 5750)
@@ -29,5 +29,5 @@
 using namespace std;
 
-CREATE_FACTORY(PhysicsConnection);
+CREATE_FACTORY(PhysicsConnection, CL_PHYSICS_CONNECTION);
 
 /**
Index: /trunk/src/story_entities/world.cc
===================================================================
--- /trunk/src/story_entities/world.cc	(revision 5749)
+++ /trunk/src/story_entities/world.cc	(revision 5750)
@@ -70,6 +70,5 @@
 
 #include "cd_engine.h"
-#include "npc.h"
-#include "npc2.h"
+#include "npcs/npc_test1.h"
 #include "shader.h"
 
@@ -81,5 +80,5 @@
 
 //! This creates a Factory to fabricate a World
-CREATE_FACTORY(World);
+CREATE_FACTORY(World, CL_WORLD);
 
 World::World(const TiXmlElement* root)
@@ -469,5 +468,5 @@
   for(int i = 0; i < 100; i++)
   {
-    WorldEntity* tmp = new NPC();
+    WorldEntity* tmp = new NPCTest1();
     char npcChar[10];
     sprintf (npcChar, "NPC_%d", i);
Index: /trunk/src/subprojects/benchmark.cc
===================================================================
--- /trunk/src/subprojects/benchmark.cc	(revision 5749)
+++ /trunk/src/subprojects/benchmark.cc	(revision 5750)
@@ -36,5 +36,5 @@
 #include <stdlib.h>
 #include <asm/msr.h>
-#include <linux/timex.h>
+//#include <linux/timex.h>
 
 
Index: /trunk/src/subprojects/collision_detection/Makefile.am
===================================================================
--- /trunk/src/subprojects/collision_detection/Makefile.am	(revision 5749)
+++ /trunk/src/subprojects/collision_detection/Makefile.am	(revision 5750)
@@ -6,4 +6,5 @@
 
 collision_LDADD = $(MAINSRCDIR)/util/libORXutils.a \
+                  $(MAINSRCDIR)/lib/physics/libORXphysics.a \
                   $(MAINSRCDIR)/lib/collision_detection/libORXcd.a \
                   $(MAINSRCDIR)/lib/libORXlibs.a \
Index: /trunk/src/subprojects/collision_detection/collision_test_entity.cc
===================================================================
--- /trunk/src/subprojects/collision_detection/collision_test_entity.cc	(revision 5749)
+++ /trunk/src/subprojects/collision_detection/collision_test_entity.cc	(revision 5750)
@@ -26,5 +26,5 @@
 
 using namespace std;
-CREATE_FACTORY(CollisionTestEntity);
+CREATE_FACTORY(CollisionTestEntity, CL_ENVIRONMENT);
 
 /**
Index: /trunk/src/subprojects/importer/Makefile.am
===================================================================
--- /trunk/src/subprojects/importer/Makefile.am	(revision 5749)
+++ /trunk/src/subprojects/importer/Makefile.am	(revision 5750)
@@ -31,3 +31,4 @@
                   $(MAINSRCDIR)/lib/util/substring.cc \
                   $(MAINSRCDIR)/lib/util/color.cc \
+                  $(MAINSRCDIR)/lib/util/multi_type.cc \
                   $(MAINSRCDIR)/util/loading/factory.cc
Index: /trunk/src/util/Makefile.am
===================================================================
--- /trunk/src/util/Makefile.am	(revision 5749)
+++ /trunk/src/util/Makefile.am	(revision 5750)
@@ -5,4 +5,5 @@
 
 libORXutils_a_SOURCES = fast_factory.cc \
+			object_manager.cc \
                         loading/factory.cc \
 			garbage_collector.cc \
@@ -18,7 +19,8 @@
 			track/pilot_node.cc \
 			track/track_manager.cc \
-			track/track_node.cc
+			track/track_node.cc 
 
 noinst_HEADERS =        fast_factory.h \
+			object_manager.h \
 			garbage_collector.h \
 			state.h \
Index: /trunk/src/util/fast_factory.cc
===================================================================
--- /trunk/src/util/fast_factory.cc	(revision 5749)
+++ /trunk/src/util/fast_factory.cc	(revision 5750)
@@ -13,5 +13,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_OBJECT_MANAGER
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_LOAD
 
 #include "fast_factory.h"
Index: /trunk/src/util/loading/factory.cc
===================================================================
--- /trunk/src/util/loading/factory.cc	(revision 5749)
+++ /trunk/src/util/loading/factory.cc	(revision 5750)
@@ -34,5 +34,5 @@
    set everything to zero and define factoryName
 */
-Factory::Factory (const char* factoryName)
+Factory::Factory (const char* factoryName, ClassID classID)
 {
   this->setClassID(CL_FACTORY, "Factory");
@@ -40,4 +40,5 @@
 
   this->next = NULL;
+  this->classID = classID;
 
   Factory::registerFactory(this);
Index: /trunk/src/util/loading/factory.h
===================================================================
--- /trunk/src/util/loading/factory.h	(revision 5749)
+++ /trunk/src/util/loading/factory.h	(revision 5750)
@@ -33,6 +33,6 @@
  * this should be used at the beginning of all the Classes that should be loadable (in the cc-file)
 */
-#define CREATE_FACTORY(CLASS_NAME) \
-    tFactory<CLASS_NAME>* global_##CLASS_NAME##_Factory = new tFactory<CLASS_NAME>(#CLASS_NAME)
+#define CREATE_FACTORY(CLASS_NAME, CLASS_ID) \
+    tFactory<CLASS_NAME>* global_##CLASS_NAME##_Factory = new tFactory<CLASS_NAME>(#CLASS_NAME, CLASS_ID)
 
 //! The Factory is a loadable object handler
@@ -40,8 +40,9 @@
 
  public:
-  Factory (const char* factoryName = NULL);
+  Factory (const char* factoryName = NULL, ClassID classID = CL_NULL);
   virtual ~Factory ();
 
   void fabricate(const char* className, const char* entityName);
+  virtual BaseObject* fabricate(ClassID classID) = NULL;
   virtual BaseObject* fabricate(const TiXmlElement* root) = NULL;
   virtual BaseObject* fabricateDirect() = NULL;
@@ -57,4 +58,8 @@
     Factory* getNext() const { return this->next; };
 
+
+  protected:
+    ClassID           classID;              //!< The CLass-Identifyer of the Factory.
+
   private:
     Factory*          next;                 //!< pointer to the next factory.
@@ -64,15 +69,16 @@
 /**
  *  a factory that is able to load any kind of Object
-   (this is a Functor)
-*/
+ * (this is a Functor)
+ */
 template<class T> class tFactory : public Factory
 {
- public:
-  tFactory(const char* factoryName);
-  virtual ~tFactory();
+  public:
+    tFactory(const char* factoryName, ClassID classID);
+    virtual ~tFactory();
 
   private:
-  virtual BaseObject* fabricate(const TiXmlElement* root);
-  virtual BaseObject* fabricateDirect();
+    virtual BaseObject* fabricate(ClassID classID);
+    virtual BaseObject* fabricate(const TiXmlElement* root);
+    virtual BaseObject* fabricateDirect();
 };
 
@@ -82,16 +88,23 @@
 */
 template<class T>
-tFactory<T>::tFactory(const char* factoryName) : Factory(factoryName)
+    tFactory<T>::tFactory(const char* factoryName, ClassID classID) : Factory(factoryName, classID)
 {
   PRINTF(4)("Class: %s loadable\n", this->getName());
 }
 
-
+/**
+ * destructs the type-Factory
+ */
 template<class T>
-tFactory<T>::~tFactory()
+    tFactory<T>::~tFactory()
 {}
 
+/**
+ * fabricates an Object of type T, with the constructor T::T(const TiXmlElemnt*)
+ * @param root the TiXmlElement T should load parameters from.
+ * @return the newly fabricated T, NULL otherwise.
+ */
 template<class T>
-BaseObject* tFactory<T>::fabricate(const TiXmlElement* root)
+    BaseObject* tFactory<T>::fabricate(const TiXmlElement* root)
 {
   if (root == NULL)
@@ -106,4 +119,24 @@
 }
 
+
+/**
+ * fabricates an Object of type T, with the constructor T::T(const TiXmlElemnt*)
+ * @param classID the ClassID of T that should be created.
+ * @return the newly fabricated T if fabricated NULL otherwise.
+ */
+template<class T>
+    BaseObject* tFactory<T>::fabricate(ClassID classID)
+{
+  if(classID == this->classID)
+    return this->fabricateDirect();
+  else if( getNext() != NULL)
+    return getNext()->fabricate( classID);
+  else
+    return NULL;
+}
+
+/**
+ * directly fabricate an Entity of this factory.
+ */
 template<class T>
     BaseObject* tFactory<T>::fabricateDirect()
Index: /trunk/src/util/object_manager.cc
===================================================================
--- /trunk/src/util/object_manager.cc	(revision 5750)
+++ /trunk/src/util/object_manager.cc	(revision 5750)
@@ -0,0 +1,43 @@
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: ...
+   co-programmer: ...
+*/
+
+//#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+#include "object_manager.h"
+
+using namespace std;
+
+
+/**
+ * standard constructor
+ */
+ObjectManager::ObjectManager ()
+{
+   this->setClassID(CL_OBJECT_MANAGER, "ObjectManager");
+   this->setName("ObjectManager");
+}
+
+/**
+ *  the singleton reference to this class
+ */
+ObjectManager* ObjectManager::singletonRef = NULL;
+
+/**
+   @brief standard deconstructor
+ */
+ObjectManager::~ObjectManager ()
+{
+  ObjectManager::singletonRef = NULL;
+}
Index: /trunk/src/util/object_manager.h
===================================================================
--- /trunk/src/util/object_manager.h	(revision 5750)
+++ /trunk/src/util/object_manager.h	(revision 5750)
@@ -0,0 +1,43 @@
+/*!
+ * @file object_manager.h
+ * @brief Definition of the ... singleton Class
+*/
+
+#ifndef _OBJECT_MANAGER_H
+#define _OBJECT_MANAGER_H
+
+#include "base_object.h"
+#include <list>
+
+// FORWARD DECLARATION
+
+
+class ObjectGroupList
+{
+
+
+
+};
+
+
+//! A default singleton class.
+class ObjectManager : public BaseObject {
+
+ public:
+  virtual ~ObjectManager(void);
+  /** @returns a Pointer to the only object of this Class */
+  inline static ObjectManager* getInstance(void) { if (!ObjectManager::singletonRef) ObjectManager::singletonRef = new ObjectManager();  return ObjectManager::singletonRef; };
+
+
+  ObjectGroupList* getGroupList( );
+
+ private:
+  ObjectManager(void);
+  static ObjectManager* singletonRef;
+
+  std::list<ObjectGroupList>           groupList;
+
+
+};
+
+#endif /* _OBJECT_MANAGER_H */
Index: /trunk/src/world_entities/Makefile.am
===================================================================
--- /trunk/src/world_entities/Makefile.am	(revision 5749)
+++ /trunk/src/world_entities/Makefile.am	(revision 5750)
@@ -25,5 +25,7 @@
                   weapons/rocket.cc \
                   weapons/laser.cc \
+		  weapons/ground_turret.cc \
                   weapons/crosshair.cc \
+		  weapons/ground_turret.cc \
                   power_ups/power_up.cc \
                   power_ups/turret_power_up.cc \
Index: /trunk/src/world_entities/environment.cc
===================================================================
--- /trunk/src/world_entities/environment.cc	(revision 5749)
+++ /trunk/src/world_entities/environment.cc	(revision 5750)
@@ -28,5 +28,5 @@
 
 using namespace std;
-CREATE_FACTORY(Environment);
+CREATE_FACTORY(Environment, CL_ENVIRONMENT);
 
 /**
Index: /trunk/src/world_entities/npcs/npc.cc
===================================================================
--- /trunk/src/world_entities/npcs/npc.cc	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc.cc	(revision 5750)
@@ -0,0 +1,80 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "npc.h"
+#include "obb_tree.h"
+
+#include "state.h"
+#include "list.h"
+#include "stdlibincl.h"
+#include "power_ups/turret_power_up.h"
+#include "power_ups/laser_power_up.h"
+
+using namespace std;
+
+
+NPC::NPC()
+{
+  this->setClassID(CL_NPC, "NPC");
+
+}
+
+
+NPC::~NPC () {}
+
+
+void NPC::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (entity->isA(CL_PROJECTILE) && entity != this->collider)
+  {
+//    PRINTF(3)("collision %s vs %s @ (%f,%f,%f)\n", this->getName(), entity->getName(), location.x, location.y, location.z);
+//    this->applyForce(Vector(0,0,0)-location*1000);
+    if ((float)rand()/RAND_MAX < .3)
+    {
+      WorldEntity* powerUp = new TurretPowerUp();
+      powerUp->setAbsCoor(this->getAbsCoor());
+      State::getWorldEntityList()->add(powerUp);
+    }
+    else if ((float)rand()/RAND_MAX < .3)
+    {
+      WorldEntity* powerUp = new LaserPowerUp();
+      powerUp->setAbsCoor(this->getAbsCoor());
+      State::getWorldEntityList()->add(powerUp);
+    }
+    State::getWorldEntityList()->remove(this);
+
+      this->collider = entity;
+  }
+  else if (entity->isA(CL_PLAYER))
+    this->applyForce(Vector(0,0,0)-location*100);
+  else if (entity->isA(CL_NPC))
+  {
+    this->setVisibiliy(false);
+    State::getWorldEntityList()->remove(this);
+  }
+}
+
+
+void NPC::tick(float dt)
+{
+
+}
+
+
+
Index: /trunk/src/world_entities/npcs/npc.h
===================================================================
--- /trunk/src/world_entities/npcs/npc.h	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc.h	(revision 5750)
@@ -0,0 +1,30 @@
+
+#ifndef _NPC_H
+#define _NPC_H
+
+#include "world_entity.h"
+#include "physics_interface.h"
+
+class AI;
+
+class NPC : public WorldEntity, public PhysicsInterface {
+
+ public:
+  NPC ();
+  ~NPC ();
+
+
+  void addAI(AI* ai);
+
+  virtual void tick(float dt);
+
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+
+
+ private:
+
+   WorldEntity* collider;
+
+};
+
+#endif /* _NPC_H */
Index: /trunk/src/world_entities/npcs/npc_test.cc
===================================================================
--- /trunk/src/world_entities/npcs/npc_test.cc	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc_test.cc	(revision 5750)
@@ -0,0 +1,120 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "npc_test.h"
+#include "obb_tree.h"
+
+#include "shader.h"
+#include "state.h"
+#include "list.h"
+#include "stdlibincl.h"
+#include "debug.h"
+
+
+using namespace std;
+
+
+NPC2::NPC2()
+{
+  this->setClassID(CL_NPC, "NPC");
+
+  if ((float)rand()/RAND_MAX > .5f)
+    this->loadModel("models/ships/bolido.obj", 3);
+  else
+    this->loadModel("models/ships/gobblin.obj", 3);
+
+  this->shader = NULL;
+  if (likely(Shader::checkShaderAbility()))
+    this->shader = Shader::getShader("shaders/toon.vert", "shaders/toon.frag");
+
+  this->obj = gluNewQuadric();
+
+  this->randomRotAxis = VECTOR_RAND(1);
+}
+
+
+NPC2::~NPC2 ()
+{
+  if (this->shader)
+    Shader::unload(this->shader);
+  gluDeleteQuadric(this->obj);
+}
+
+
+void NPC2::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (entity->isA(CL_PROJECTILE))
+  {
+    PRINTF(3)("collision %s vs %s @ (%f,%f,%f)\n", this->getName(), entity->getName(), location.x, location.y, location.z);
+    this->applyForce(Vector(0,0,0)-location*1000);
+  }
+  else if (entity->isA(CL_PLAYER))
+    this->applyForce(Vector(0,0,0)-location*100);
+  else
+  {
+    this->setVisibiliy(false);
+   State::getWorldEntityList()->remove(this);
+  }
+}
+
+
+/**
+ *  the entity is drawn onto the screen with this function
+ *
+ * This is a central function of an entity: call it to let the entity painted to the screen.
+ * Just override this function with whatever you want to be drawn.
+ */
+void NPC2::draw() const
+{
+  glMatrixMode(GL_MODELVIEW);
+  glPushMatrix();
+  float matrix[4][4];
+
+  /* translate */
+  glTranslatef (this->getAbsCoor ().x,
+                this->getAbsCoor ().y,
+                this->getAbsCoor ().z);
+  /* rotate */
+  this->getAbsDir ().matrix (matrix);
+  glMultMatrixf((float*)matrix);
+
+  if (this->shader != NULL && this->shader != Shader::getActiveShader())
+    shader->activateShader();
+  gluSphere(this->obj, 3, 10, 10);
+  shader->deactivateShader();
+
+
+/*  if (this->model)
+    this->model->draw();*/
+  glPopMatrix();
+}
+
+
+void NPC2::tick(float dt)
+{
+//  Vector direction = (State::getCameraTarget()->getAbsCoor() - this->getAbsCoor());
+
+  //if (directin.len() < 100)
+//  this->shiftCoor(direction *dt * 5 * exp(-direction.len() / 30.0));
+  this->shiftDir(Quaternion(dt, this->randomRotAxis));
+
+}
+
+
+
Index: /trunk/src/world_entities/npcs/npc_test.h
===================================================================
--- /trunk/src/world_entities/npcs/npc_test.h	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc_test.h	(revision 5750)
@@ -0,0 +1,35 @@
+
+#ifndef _NPC22_H
+#define _NPC2_H
+
+#include "world_entity.h"
+#include "physics_interface.h"
+
+#include "glincl.h"
+
+class AI;
+class Shader;
+
+class NPC2 : public WorldEntity, public PhysicsInterface {
+
+ public:
+  NPC2 ();
+  ~NPC2 ();
+
+
+  void addAI(AI* ai);
+
+  virtual void tick(float dt);
+  virtual void draw() const;
+
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+
+
+ private:
+   Vector   randomRotAxis;
+   Shader*  shader;
+   GLUquadricObj* obj;
+
+};
+
+#endif /* _NPC2_H */
Index: /trunk/src/world_entities/npcs/npc_test1.cc
===================================================================
--- /trunk/src/world_entities/npcs/npc_test1.cc	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc_test1.cc	(revision 5750)
@@ -0,0 +1,91 @@
+
+
+/*
+   orxonox - the future of 3D-vertical-scrollers
+
+   Copyright (C) 2004 orx
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; either version 2, or (at your option)
+   any later version.
+
+   ### File Specific:
+   main-programmer: Patrick Boenzli
+   co-programmer:
+*/
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_WORLD_ENTITY
+
+
+#include "npc_test1.h"
+#include "obb_tree.h"
+
+#include "state.h"
+#include "list.h"
+#include "stdlibincl.h"
+#include "power_ups/turret_power_up.h"
+#include "power_ups/laser_power_up.h"
+
+using namespace std;
+
+
+NPCTest1::NPCTest1()
+{
+  this->setClassID(CL_NPC, "NPCTest1");
+
+  if ((float)rand()/RAND_MAX > .5f)
+    this->loadModel("models/ships/bolido.obj", 2);
+  else
+    this->loadModel("models/ships/gobblin.obj", 2);
+
+  this->randomRotAxis =  VECTOR_RAND(1);
+}
+
+
+NPCTest1::~NPCTest1 () {}
+
+
+void NPCTest1::collidesWith(WorldEntity* entity, const Vector& location)
+{
+  if (entity->isA(CL_PROJECTILE) && entity != this->collider)
+  {
+//    PRINTF(3)("collision %s vs %s @ (%f,%f,%f)\n", this->getName(), entity->getName(), location.x, location.y, location.z);
+//    this->applyForce(Vector(0,0,0)-location*1000);
+    if ((float)rand()/RAND_MAX < .3)
+    {
+      WorldEntity* powerUp = new TurretPowerUp();
+      powerUp->setAbsCoor(this->getAbsCoor());
+      State::getWorldEntityList()->add(powerUp);
+    }
+    else if ((float)rand()/RAND_MAX < .3)
+    {
+      WorldEntity* powerUp = new LaserPowerUp();
+      powerUp->setAbsCoor(this->getAbsCoor());
+      State::getWorldEntityList()->add(powerUp);
+    }
+    State::getWorldEntityList()->remove(this);
+
+      this->collider = entity;
+  }
+  else if (entity->isA(CL_PLAYER))
+    this->applyForce(Vector(0,0,0)-location*100);
+  else if (entity->isA(CL_NPC))
+  {
+    this->setVisibiliy(false);
+    State::getWorldEntityList()->remove(this);
+  }
+}
+
+
+void NPCTest1::tick(float dt)
+{
+//  Vector direction = (State::getCameraTarget()->getAbsCoor() - this->getAbsCoor());
+
+  //if (directin.len() < 100)
+//  this->shiftCoor(direction *dt * 5 * exp(-direction.len() / 30.0));
+  this->shiftDir(Quaternion(dt, this->randomRotAxis));
+
+}
+
+
+
Index: /trunk/src/world_entities/npcs/npc_test1.h
===================================================================
--- /trunk/src/world_entities/npcs/npc_test1.h	(revision 5750)
+++ /trunk/src/world_entities/npcs/npc_test1.h	(revision 5750)
@@ -0,0 +1,31 @@
+
+#ifndef _NPC_Test1_H
+#define _NPC_Test1_H
+
+#include "world_entity.h"
+#include "physics_interface.h"
+
+class AI;
+
+class NPCTest1 : public WorldEntity, public PhysicsInterface {
+
+ public:
+  NPCTest1 ();
+  ~NPCTest1 ();
+
+
+  void addAI(AI* ai);
+
+  virtual void tick(float dt);
+
+  virtual void collidesWith (WorldEntity* entity, const Vector& location);
+
+
+ private:
+   Vector   randomRotAxis;
+
+   WorldEntity* collider;
+
+};
+
+#endif /* _NPC_Test1_H */
